#include "LinAlgVectorComplex.h"

LinAlgVectorComplex::LinAlgVectorComplex(int m)
{
	assert(m>0);
	m_aComplexData = new LinAlgComplex[m];

	this->m = m;
}

void LinAlgVectorComplex::PrintMatlab()
{
	std::cout<<"[ ";
	for (int i=0; i<m; i++)
	{
		std::string endChar=", ";
		if (i==m-1)
			endChar="";
		if (m_aComplexData[i].i>0)
			std::cout<<m_aComplexData[i].r<<"+"<<m_aComplexData[i].i<<"i"<<endChar.c_str();
		else if (m_aComplexData[i].i<0)
			std::cout<<m_aComplexData[i].r<<m_aComplexData[i].i<<"i"<<endChar.c_str();
		else
			std::cout<<m_aComplexData[i].r<<endChar.c_str();
	}
	std::cout<<"]"<<std::flush;
}

LinAlgVectorComplex::~LinAlgVectorComplex()
{
	delete [] m_aComplexData;
}

LinAlgComplex & LinAlgVectorComplex::operator()(int i)
{
	assert(i<m && i>=0);
	return m_aComplexData[i];
}

LinAlgComplex LinAlgVectorComplex::GetValue(int i) const
{
	return (*(LinAlgVectorComplex*)this)(i);
}

void LinAlgVectorComplex::SetValue(int i, const LinAlgComplex & value)
{
	(*this)(i) = value;
}


int LinAlgVectorComplex::Rows() const
{
	return m;
}

