/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __AppLabeling_H
#define __AppLabeling_H

#include "PipelineStepApplication.h"
#include "AnalysisPipeline.h"
#include "DatabaseVisWindow.h"
#include "ModelDatabase.h"
#include "ModelValueLabel.h"

class AppLabeling : public PipelineStepApplication
{
	public: 
		AppLabeling(AnalysisPipeline & pipeline, const VKString & moduleName);
		
		virtual VKString GetAppType();
		virtual void Execute();
		virtual void Draw(DatabaseVisWindow * window);
		
		virtual void WriteResultsChild(std::ofstream & textStream);	
		virtual bool ReadResultsChild(std::ifstream & textStream);
	
	protected:
		virtual void LabelModel(int modelID, const VKString & modelName);
		virtual void FillLabelsAtAPoint(const ModelPoint & pnt, 
										VKStringList & labels, std::vector<double> & labelValues);
	
		virtual int NumLabelParams();
		virtual void FillPtrsFromParams(int id);
		virtual void FillPtrsForDraw(DatabaseVisWindow * window);
		virtual void FillPtrs(const VKString & corrCollection, int corrID, const VKString & corrValue, 
							  VKStringList & labelsList);
	
	
		CorrCollection * m_pCorrs;
		CorrValue * m_pCorrVals;
	
		VKStringList m_sModelLabelsValName;
	
		VKStringList m_sCreatedModelValues;
	
		ModelPoint m_CachedPnt;
		VKStringList m_CachedLabels;
		std::vector<double> m_CachedLabelValues;
	
		virtual int GetSegID(const VKString & label);
		virtual void AssignGlobalLabels(ModelValueLabel * labelValue);
		std::map<VKString, int> m_GlobalLabelToSegID;
};
	

#endif

