/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/


#ifndef __CollectionSinglePair_H
#define __CollectionSinglePair_H

#include <map>

#include "VKString.h"

#include "ModelPoint.h"

#include "CorrCollection.h"

class CorrValue;
class Model3D;
class ModelDatabase;

class ModelCorrRenderingParams
{
	public:
		enum CorrDrawStyle
		{
			CORR_DRAW_VALUE_TRANSFER,
			CORR_DRAW_CORR_VALUE,
			CORR_DRAW_EDGES,
			CORR_DRAW_POINT_COLORS,
		};
	
		bool m_bOnlyAtSelectedPoint;
		
	
		VKString m_sModelValueName;
		VKString m_sPointSetName;
};

class CollectionSinglePair : public CorrCollection
{
	public:
		CollectionSinglePair(const VKString & collectionName, 
							 ModelDatabase * db, int corrID=-1);
		CollectionSinglePair(const VKString & modelFrom, const VKString & modelTo,
							 const VKString & collectionName, 
							 ModelDatabase * db, int corrID=-1);
		virtual ~CollectionSinglePair();
	
	// Implement in a child:
		virtual VKString GetCollectionType();
	
		//virtual void DrawCollectionCorrValue(const ModelPoint & selected, 
		//										const VKString & corrValueName);
	///////////
	
	// Rendering
//		virtual void DrawCorrEdges(const VKString & pickFromSet);
//		virtual void DrawCorrEdge(const ModelPoint & pnt, int numPnts);
//		virtual void DrawByValueTransfer(const VKString & modelValue);
	
		virtual Model3D * ModelFrom();
		virtual Model3D * ModelTo();
	
		virtual bool ReadModelPair(std::ifstream & textStream);
		virtual void WriteModelPair(std::ofstream & textStream);

	
	protected:
		Model3D * m_pModelFrom;
		Model3D * m_pModelTo;
	
		VKString m_sModelFromName;
		VKString m_sModelToName;
	
		VKString m_sInverseCollection;
		int m_iInverseCorrID;
};

#endif

