/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/


#ifndef __CorrValueAlignDist_H
#define __CorrValueAlignDist_H

#include "CorrValue.h"
#include "CorrValuePairwise.h"

class ModelCorr;
class SinglePairRigidAlign;
class ModelDatabase;
class PointDescriptor;

class CorrValueAlignDist : public CorrValuePairwise
{
	public:
		CorrValueAlignDist(ModelDatabase * db, const VKString & corrCollection, 
						   int corrID, const VKString & corrValueName, 
						   const VKString & pointDescriptor);
		virtual ~CorrValueAlignDist();
	
		virtual double CalculateValue(const ModelPoint & fromPnt, const ModelPoint & toPnt);
		virtual void FillPtrs();
		virtual void ClearPtrs();
	
		// implement in a child
		virtual VKString CorrValueType();
	
		virtual double IntegratedValue(const VKString & domainModel, 
									   const VKString & domainPntSet = "auto",
									   const VKString & rangeModel = "auto", 
									   const VKString & rangeoPntSet = "auto", 
									   IntOperator op = INT_OP_SUM_OF_MAX,
									   bool symmetric = true);
	
//		virtual void AddSmoothedCorrs(const ModelPoint & fromPnt, 
//									  std::vector<ModelPoint> & toPnts);
//		virtual double GetSmoothedDistance(const ModelPoint & fromPnt, 
//										   const ModelPoint & toPnt);
	
	protected:
		/////////
		virtual bool ReadCorrValueChild(std::ifstream & textStream);
		virtual void WriteCorrValueChild(std::ofstream & textStream);
		
	
	protected: 
//		std::map<ModelPoint, double > * m_aGaussianWeights;
//		int m_iSizeOfWeightsArray;
		double m_fGlobalAlignmentScore;
		
		VKString m_sPointDescriptorsSet;
		PointDescriptorsContainer * m_pContainerSet1;
		PointDescriptorsContainer * m_pContainerSet2;
	
		double m_fMaxDistSigma2;
		SinglePairRigidAlign * m_pCorrRigidAlign;
		
		
};

#endif


