/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __CorrValuePairwise_H
#define __CorrValuePairwise_H

#include "CorrValue.h"
#include "CollectionSinglePair.h"

class CorrValuePairwise : public CorrValue
{
	public:
		CorrValuePairwise(ModelDatabase * db, const VKString & corrCollectionName, 
						  int corrID, const VKString & corrValueName, int flags);
		virtual ~CorrValuePairwise();
	
		virtual CorrValuePairwise * GetSelfAsPairwise();
	
	
		virtual Model3D * ModelFrom();
		virtual Model3D * ModelTo();
		
		virtual double GetCachedValue(const ModelPoint & fromPnt, 
									  const ModelPoint & toPnt, bool & valid);
		virtual void SetCacheValue(const ModelPoint & fromPnt, 
								   const ModelPoint & toPnt, double value);
		
		// implement in a child:	
		virtual VKString CorrValueType();
		
	protected:
		virtual bool ReadCachedValues(std::ifstream & textStream);
		virtual	void WriteCachedValues(std::ofstream & textStream);	
		/////////////
	
	protected:
		int GetPointIDInArray(const ModelPoint & fromPnt);
		virtual double GetCachedValueFromArray(const ModelPoint & fromPnt, const ModelPoint & toPnt, bool & valid);
		virtual void SetCacheValueFromArray(const ModelPoint & fromPnt, const ModelPoint & toPnt, double value);
		
		int m_iArraySize;
		std::map<ModelPoint, double> * m_aArbitraryPairValuesArray;
	
		virtual bool ReadCachedValuesArray(std::ifstream & textStream);
		virtual void WriteCachedValuesArray(std::ofstream & textStream);
};

#endif
