/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __PipelineStepApplication_H
#define __PipelineStepApplication_H

#include "AnalysisPipeline.h"
#include "DatabaseVisWindow.h"
#include "ModelDatabase.h"

class PipelineStepApplication
{
	public: 
		PipelineStepApplication(AnalysisPipeline & pipeline, const VKString & moduleName);
		
		virtual bool CaptureKeyPressed(DatabaseVisWindow * window, 
									   const char key, int mouseX, int mouseY);
		virtual bool CaptureMouseButtonEvent(DatabaseVisWindow * window, int x, int y, 
											 VisWindow::MouseButton mouseButtonID, 
											 VisWindow::MouseButtonState newState);
		virtual bool CaptureMouseMotionEvent(DatabaseVisWindow * window, 
											 int x, int y, int dx, int dy);
		virtual void InteractAppEnabled(DatabaseVisWindow * window);
		virtual void InteractAppDisabled(DatabaseVisWindow * window);
	
		virtual VKString GetAppType() = 0;
		virtual void Execute() = 0;
		virtual void Draw(DatabaseVisWindow * window);
		
		virtual void WriteResults();
		virtual void WriteResultsChild(std::ofstream & textStream);
		
		static bool ReadResults(AnalysisPipeline & pipeline, const VKString & moduleName);
		virtual bool ReadResultsChild(std::ifstream & textStream);
	
	protected:
		VKString m_sAppName;
		AnalysisPipeline & m_Pipeline;
		//ModelDatabase * m_pDB;
		VKString m_sModuleName;
};
	

#endif

