/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __ShapeDescriptorSimple_H
#define __ShapeDescriptorSimple_H

#include "ShapeDescriptor.h"

/**
 * Shape distribution function
 */
class DescriptorShapeDistribution : public ShapeDescriptor
{
	public:
		DescriptorShapeDistribution(Model3D * model, double sigma, int nBins,
									const VKString & modelDistance, const VKString & pointsName);		
		virtual void FillDescriptorValues();
		
	protected:
		double m_fSigma;
		int m_iNBins;
		VKString m_sDistances;
		VKString m_sPointsName;
};

class DescriptorRandom : public ShapeDescriptor
{
	public:
		DescriptorRandom(Model3D * model, int nModels);
		virtual void FillDescriptorValues();
		virtual void FindMyNearestNeighbors(std::vector<ShapeDescriptor*> & otherDescriptors, 
											int nNeighbors, 
											std::vector<ShapeDescriptor*> & neighbors,
											std::vector<double> * distances);
	
		int m_iNModels;
};

#endif
