/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __SinglePairSmooth_H
#define __SinglePairSmooth_H

#include "CollectionSinglePair.h"

class SinglePairSmooth : public CollectionSinglePair
{
	public:
		SinglePairSmooth(const VKString & collectionName, ModelDatabase * db, int corrID);
	
		SinglePairSmooth(const VKString & collectionName,
						 ModelDatabase * db, 
						 int corrID,
						 const VKString & nonSmoothCorrCollection, 
						 int nonSmoothCorrID,
						 const VKString & distanceMetric,
						 double maxDistance);
		virtual ~SinglePairSmooth();
	
		virtual void DrawSpecial(DatabaseVisWindow * window);
	
		virtual bool ReadCollectionChild(std::ifstream & textStream);
		virtual void WriteCollectionChild(std::ofstream & textStream);

	
		virtual void GetCorrs(const ModelPoint & pnt,	
							  std::vector<ModelPoint> * corrPnts);
		virtual VKString GetCollectionType();
	
		virtual void FillPtrs();
	
		virtual VKString GetNonSmoothCollectionName(int & nonSmoothID);
	
	protected:
		VKString m_sNonSmoothCorrCollection;
		int m_iNonSmoothCorrID;
		VKString m_sDistanceMetric;
		double m_fMaxDist;
	
		CollectionSinglePair * m_pCorrs;
		ModelDistance * m_pDistance;
};


#endif

